<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:x="http://www.w3.org/TR/xpath"
                xmlns="http://www.w3.org/TR/xpath"
                exclude-result-prefixes="xalan x">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

    <xsl:template match="/x:paths">
        <xsl:copy>
            <xsl:for-each select="x:path">
                <xsl:copy><xsl:copy-of select="@*"/>
                    <xsl:attribute name="depth"><xsl:apply-templates select="."/></xsl:attribute>
                </xsl:copy>
            </xsl:for-each>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="x:path">
        <xsl:choose>
            <!-- future from root node -->
            <xsl:when test="@absolute='true' or
                x:NameStep[@axis='preceding' or @axis='following'] or
                x:NameStep[starts-with(@axis,'ancestor')]/following-sibling::x:*[
                    self::x:NameStep[@axis='child' or starts-with(@axis,'descendant') or contains(@axis,'-sibling')] |
                    self::x:TextNodeStep |
                    self::x:CommentNodeStep |
                    descendant::x:Function[@s1='position' or @s1='last'] |
                    descendant::x:Predicate[count(*)=1]/x:PathExpr[count(*)=1]/x:FilterExpr[count(*)=1]/x:Number
            ]">
                <xsl:text>666</xsl:text>
            </xsl:when>

            <!-- future from subtree -->
            <xsl:when test="x:*[
                self::x:NameStep[contains(@axis,'-sibling')] |
                descendant::x:Function[@s1='position' or @s1='last'] |
                descendant::x:Predicate[count(*)=1]/x:PathExpr[count(*)=1]/x:FilterExpr[count(*)=1]/x:Number
            ]">
                <xsl:value-of select="count((x:NameStep | x:AllNodeStep)[@axis='parent']) + 1"/>
            </xsl:when>
            <xsl:when test="x:*[
                self::x:NameStep[@axis='child' or starts-with(@axis,'descendant')] |
                self::x:TextNodeStep |
                self::x:CommentNodeStep
            ]">
                <xsl:value-of select="count((x:NameStep | x:AllNodeStep)[@axis='parent'])"/>
            </xsl:when>
            <xsl:when test="x:*[@axis='parent'] and not(x:*[last()][@axis='attribute'])">
                <xsl:value-of select="count((x:NameStep | x:AllNodeStep)[@axis='parent'])"/>
            </xsl:when>

            <!-- no future -->
            <xsl:otherwise>
                <xsl:text>-1</xsl:text>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>